%define major 6
%define libname %mklibname ffi %{major}
%define develname %mklibname -d ffi
Name:		libffi
Version:	3.2.1
Release:	%mkrel 1
Summary:	A portable foreign function interface library
Group:		System/Libraries
License:	BSD
URL:		http://sourceware.org/libffi
Source0:	ftp://sourceware.org/pub/%{name}/%{name}-%{version}.tar.xz
Patch0:		libffi-3.1-fix-include-path.patch

%description
Compilers for high level languages generate code that follow certain
conventions.  These conventions are necessary, in part, for separate
compilation to work.  One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function.
A calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call
a given function.  `Libffi' can be used in such programs to provide
a bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions.  This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface.  A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language. 
The `libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface.  A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

%package -n	%{libname}
Summary:	A portable foreign function interface library
Group:		System/Libraries
Provides:       %{name} = %{version}-%{release}
Provides:       %{name}%{major} = %{version}-%{release}

%description -n	%{libname}
Compilers for high level languages generate code that follow certain
conventions.  These conventions are necessary, in part, for separate
compilation to work.  One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function.
A calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call
a given function.  `Libffi' can be used in such programs to provide
a bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions.  This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface.  A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language.
The `libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface.  A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

%package -n	%{develname}
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Requires(post):	/sbin/install-info
Requires(preun): /sbin/install-info
Provides:	libffi-devel = %{version}-%{release}
Provides:	ffi%{major}-devel = %{version}-%{release}
Obsoletes:	%{mklibname -d ffi 5}
Obsoletes:	%{mklibname -d ffi 6}

%description -n	%{develname}
This package contains libraries and header files for developing
applications that use %{name}.


%prep
%setup -q
%apply_patches


%build
autoreconf -vfi
%configure2_5x --disable-static
%make


%install
rm -rf %buildroot
%makeinstall_std LIBDIR=%{_libdir}
find %{buildroot} -name '*.la' -exec rm -f {} ';'
rm -f %{buildroot}%{_infodir}/dir

# (tv) move includes in std path (needed for LLVM):
mkdir -p $RPM_BUILD_ROOT%{_includedir}
mv $RPM_BUILD_ROOT%{_libdir}/libffi-%{version}/include/{ffi,ffitarget}.h $RPM_BUILD_ROOT%{_includedir}

%multiarch_includes %{buildroot}%{_includedir}/ffi.h
%multiarch_includes %{buildroot}%{_includedir}/ffitarget.h

%post -n %{develname}
%_install_info libffi.info

%preun -n %{develname}
%_remove_install_info libffi.info


%files -n %{libname}
%doc LICENSE README
%{_libdir}/*.so.%{major}*

%files -n %{develname}
%{_libdir}/pkgconfig/*.pc
%{_libdir}/*.so
%{_mandir}/man3/*
%{_infodir}/libffi.info.*
%{_includedir}/ffi*.h
%multiarch %{multiarch_includedir}/ffi*.h


%changelog
* Fri Jul 22 2016 bb <bb> 3.2.1-1pclos2016
- update

